import { N as NonEmptyArray } from './types-XeGPaqSW.cjs';
import 'type-fest';

/**
 * Compute the product of the numbers in the array, or return 1 for an empty
 * array.
 *
 * @param data - The array of numbers.
 * @signature
 *   R.product(data);
 * @example
 *   R.product([1, 2, 3]); // => 6
 *   R.product([]); // => 1
 * @dataFirst
 * @category Number
 */
declare function product(data: ReadonlyArray<number>): number;
declare function product(data: Readonly<NonEmptyArray<bigint>>): bigint;
/**
 * Compute the product of the numbers in the array, or return 1 for an empty
 * array.
 *
 * @signature
 *   R.product()(data);
 * @example
 *   R.pipe([1, 2, 3], R.product()); // => 6
 *   R.pipe([], R.product()); // => 1
 * @dataLast
 * @category Number
 */
declare function product(): (data: ReadonlyArray<number>) => number;
declare function product(): (data: Readonly<NonEmptyArray<bigint>>) => bigint;

export { product };
